'###############################
'##                           ##
'##      Attiny25             ##
'##  Fusbyte-Resetter  	      ##
'##                           ##
'##    Original               ##
'##    Attiny13      	      ##
'##  Fusbyte-Writer           ##
'##                           ##
'##     (c)  2011             ##
'##        Anse               ##
'##		              ##
'##   Modifizierte Tab1       ##
'##   fr Tiny25 by DG6JS     ##
'##                           ##
'###############################

$regfile = "attiny25.dat"
$crystal = 1200000		'1000000 (8000000) eigentlich egal, da die 
				'Frequenz von der Einstellung in den Fusebits abhngig ist
$hwstack = 8			'32
$swstack = 4			'8
$framesize = 4			'24

 Dim D As Byte
 Dim E As Byte       '1. Spalte: Pins am schreibenden AVR
 Dim F As Byte      '2. Spalte: Pins am Verfusten AVR
                         'Spalte 1      Spalte 2
Sdi Alias Portb.4       ' Pin3          Pin5
Config Sdi = Output

Sii Alias Portb.3       ' Pin2          Pin6
Config Sii = Output

Sci Alias Portb.2       ' Pin7          Pin2
Config Sci = Output

Vcc Alias Portb.1       ' Pin6          Pin8
Config Vcc = Output

Hvolt Alias Portb.0       'Pin5  ber 10k an die Basis des BC547
Config Hvolt = Output

Do
Hvolt = 1 '12V am Rest aus
Sdi = 0
Sii = 0
Sci = 0
Vcc = 0
Waitms 50
Vcc = 1   'Versorgungsspannung fr den zurck zu setzenden Tiny einschalten
Waitms 10
Hvolt = 0 '12V am Reset an
Waitms 10

'High Bits schreiben
For D = 0 To 43
E = Lookup(d , Tab1)
F = Lookup(d , Tab2)
Sdi = E
Sii = F
Waitms 10
Sci = 1
Waitms 10
Sci = 0
Waitms 10
Next D

Waitms 500

'Low Bits schreiben
For D = 44 To 87
E = Lookup(d , Tab1)
F = Lookup(d , Tab2)
Sdi = E
Sii = F
Waitms 10
Sci = 1
Waitms 10
Sci = 0
Waitms 10
Next D

Sdi = 0   'Progammierleitungen auf low
Sii = 0
Waitms 100
Hvolt = 1 '12V am Reset aus
Waitms 10
Vcc = 0

Powerdown 'Ein Reset startet das Programm erneut
Loop
End

Tab1:
'H40
Data 0 , 0 , 1 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0
'HighByte fr Attiny25 
Data 0 , 1 , 1 , 0 , 1 , 1 , 1 , 1 , 1 , 0 , 0              
'H00                                              'fr Tiny13     0 , 1 , 1 , 1 , 1 , 1 , 1 , 1 , 1 , 0 , 0
Data 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0
'H00
Data 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0
'H40
Data 0 , 0 , 1 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0
'LowByte fr Atiny25  
Data 0 , 0 , 1 , 1 , 0 , 0 , 0 , 1 , 0 , 1 , 0              
'H00                                               'fr Tiny 13    0 , 0 , 1 , 1 , 0 , 1 , 0 , 1 , 0 , 1 , 0
Data 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0
'H00
Data 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0

Tab2:
'H4c
Data 0 , 0 , 1 , 0 , 0 , 1 , 1 , 0 , 0 , 0 , 0
'H2c
Data 0 , 0 , 0 , 1 , 0 , 1 , 1 , 0 , 0 , 0 , 0
'H74
Data 0 , 0 , 1 , 1 , 1 , 0 , 1 , 0 , 0 , 0 , 0
'H7C
Data 0 , 0 , 1 , 1 , 1 , 1 , 1 , 0 , 0 , 0 , 0
'H4c
Data 0 , 0 , 1 , 0 , 0 , 1 , 1 , 0 , 0 , 0 , 0
'H2c
Data 0 , 0 , 0 , 1 , 0 , 1 , 1 , 0 , 0 , 0 , 0
'H64
Data 0 , 0 , 1 , 1 , 0 , 0 , 1 , 0 , 0 , 0 , 0
'H6c
Data 0 , 0 , 1 , 1 , 0 , 1 , 1 , 0 , 0 , 0 , 0
